unit basehistory;
// basis klasse waar history, buffer en gerelateerde objecten vanaf leiden
// Tevens enkele helper procedures voor beeld handling die "context" nodig hebben,
// en daarom niet in "image" kunnen.

interface
{$i vwrdefines.inc}
Uses GlobalDefs,baseImage,graphics,classes,contnrs,candelautils,
     basestreaming,stdctrls,baseoverlay;

Const
   HistoryVersion = $00000002;

Type
     TRedenSet =  TSetofReden;
     PRedenSet =  ^tredenset;
     TRedenIntArray = Array [TReden] of Integer;
     TSelectedEnum  = (isselected =0,lastenum=31);
     TSelectSet     = set of TSelectedEnum;

     TBasisPictureContextObject = class
                           // non persistent.
                            isok:boolean;
                            camnr : integer;  // for filename generation purposes.
                            listnr: integer;  // list to add this image too. For capturing live image to list

                            constructor create; virtual;
                            procedure assign(source:TBasisPictureContextObject);virtual;
                            function toname (id:int64;reden:TReden;dt:TDateTime):string;virtual;
                            procedure SaveToStream(Stream: TStream); virtual;
                            procedure LoadFromStream(Stream: TStream); virtual;
                         end;
     TAddToListProc   = procedure (s:string;obj:TBasisPictureContextObject) of object;
     TVersionedPictureContextObject = class(TBasisPictureContextObject)
                            version:integer;
                            redenen:TRedenset;

                            procedure SaveToStream(Stream: TStream); override;
                            procedure LoadFromStream(Stream: TStream); override;
                         end;

     TBasisPictureContextClass = Class Of TBasisPictureContextObject;

     TBasisPicturePool = Class
                            lst : tthreadlist;
                            ftype : TBasisPictureContextClass;
                            constructor create(ctype:TBasisPictureContextClass);
                            destructor Destroy; override;
                            function get:TBasisPictureContextObject;
                            procedure put(t:TBasisPictureContextObject);
                            end;

     TBaseFotoHistory = class // foute naam, is eigenlijk de buffer.
                            procedure   save (volgnr:int64;e:tbaseimage;m:Tbasicoverlay;userobj:TBasisPictureContextObject;dtime:TDateTime=0.0); virtual;abstract;
                            procedure   savetospool (w:TReden;userdata:TBasisPictureContextObject;nr:integer=0);  virtual; abstract;
                          procedure   dosedwrite; virtual; abstract;
                          end;
     TBaseFotoHistoryClass = class of TBaseFotoHistory;

     TBasePersistentPicturesRegistry = class(TVersionedObject)
                              procedure add(naam: string; redenen: TRedenset;dt: TDateTime;bits:TSelectset);virtual; abstract;
                              procedure flush(dt:TDateTime); virtual; abstract; // flush everything older then...
                            end;


var RedenDir : array[TReden] of String;
//    RedenNaam: array[TReden] of String;

var beeldcounter : array[0..10] of integer =(0,0,0,0,0,0, 0,0,0,0,0);
    startup      : int64;

procedure maakmappen(apath:string='';ExportPaths:boolean=false);
function getnewpictimestamp(cam:integer) :int64;
function getdefaultdir : string;

procedure loadnewstylebmp(name: string;bmp:tbaseimage;meta:TBasicOverlay; context:TBasisPictureContextObject);
procedure savenewstylebmp(name: string;bmp:tbaseimage;meta:TBasicOverlay; context:TBasisPictureContextObject); overload;
procedure directsavebeeld(Red:TReden;beeld:tbaseimage;meta:TBasicOverlay;cam:integer=1); overload;

procedure loadreden(c:tcombobox;currentset:TRedenSet=[low(treden)..high(treden)]);
procedure setreden(c:Tcombobox;r:treden);

//procedure dumpdebug;

function ldstr(str:Tstream):ansiString;
procedure wrstr(str:tstream;s:ansistring);

    {$ifdef unifiedpersist}
var    
    unifiedpersist :TBasePersistentPicturesRegistry =nil;
    {$endif}
implementation

uses sysutils,typinfo;
{ TBasisPictureContextObject }

procedure loadreden(c:tcombobox;currentset:TRedenSet);
var r :treden;
begin
  for r :=low(Treden) to high(treden) do
    if r in currentset then
      c.AddItem(redennamen[r],pointer(r));
end;

procedure setreden(c:Tcombobox;r:treden);
var i,j:integer;
begin
  i:=0; j:=c.Items.count;
  while (i<j) and (integer(c.Items.objects[i])<>integer(r)) do inc(i);
  if i=j then
    i:=0;
  c.ItemIndex:=i;
end;

const  epoch=    36526.0; // 2000-1-1

procedure TBasisPictureContextObject.assign(
  source: TBasisPictureContextObject);
begin
 // ook al bla;
end;

constructor TBasisPictureContextObject.create;
begin
 // bla;
end;

{ TBasisPicturePool }
constructor TBasisPicturePool.create(ctype: TBasisPictureContextClass);
begin
  ftype:=ctype;
  lst:=TThreadList.Create;
end;

destructor TBasisPicturePool.Destroy;
{$ifdef dodeallocate}
  var l: tlist;
    i : integer;
{$endif}
begin
  {$ifdef dodeallocate}
    l:=lst.LockList;
    for i := 0 to L.Count - 1 do
     tobject(l[i]).free;
  {$endif}

   lst.free;
  inherited;
end;

function TBasisPicturePool.get: TBasisPictureContextObject;
var cnt:integer;
    v : tlist;
begin
  v:=lst.LockList;
  cnt:=v.Count;
  if cnt>0 then
    begin
      result:=v[cnt-1];
      v.delete(cnt-1);
    end
  else
      result:=ftype.create;
  lst.UnlockList;
end;

procedure TBasisPicturePool.put(t: TBasisPictureContextObject);
var
    v : Tlist;
begin
  if assigned(t) then
    begin
       // sometimes 0 byte images are returned. Probably GUI images that are never filled.
       // when massively creating and destroying bw8images, system gets unstable Probably
       // the gui widgets referenced in bw8image?
       // Dalsa is also a problem since it sometimes behaves funny if you have odd number of lines. (rounds up to even)
          v:=lst.LockList;
          v.Add(t);
          lst.unlocklist;
    end;
//  t:=nil;
end;

procedure wrstr(str:tstream;s:ansistring);
var w: word;

begin
  w:=length(s);
  str.Write(w,2);
  if w<>0 then
   str.write(s[1],w);
end;

function ldstr(str:Tstream):ansiString;
var w: word;

begin
  str.read(w,2);
  if w<>0 then
    begin
      setlength(result,w);
      str.read(result[1],w);
    end;
end;

procedure TBasisPictureContextObject.LoadFromStream(Stream: TStream);
var s : String;
begin
  s:=ldstr(stream);
  isok:=s=classname;
  {$ifdef testdebug}
  if not isok then
    stringnaarfile(getexedir+'testdebug.log','invalid class ' +s+' : '+classname);
  {$endif}
end;

procedure TBasisPictureContextObject.SaveToStream(Stream: TStream);
begin
  wrstr(stream,classname);
end;

function TBasisPicturecontextobject.toname(id: int64; reden: TReden;dt:TDateTime): string;
var s2:string;
begin
  s2:=IntToStr( id);
  result:=StringOfChar('0', 19 - Length(s2)) +s2+
                   '_' + FormatDateTime('ddmmyyyy_hhnnss', dt);
end;


procedure maakmappen(apath:string='';ExportPaths:boolean=false);

var
    wrn : TReden;

begin
 if apath='' then
   apath:=getexedir;
 apath:=IncludeTrailingPathDelimiter(apath);
 if exportpaths then
   begin
     for wrn:=low(TReden) to high(TReden) do
       begin
         redendir[wrn]:=apath+GetEnumName(typeinfo(TReden),ord(wrn));
//         redennaam[wrn]:=GetEnumName(typeinfo(TReden),ord(wrn));
         if not DirectoryExists(redendir[wrn]) then
          CreateDir(redendir[wrn] );
       end;
   end
 else
   begin
      for wrn:=low(TReden) to high(TReden) do
       begin
         redendir[wrn]:='';
//         redennaam[wrn]:=GetEnumName(typeinfo(TReden),ord(wrn));
       end;

     wrn:=product_nietok;
     redendir[wrn]:=apath+GetEnumName(typeinfo(TReden),ord(wrn));
//     redennaam[wrn]:=GetEnumName(typeinfo(TReden),ord(wrn));
     if not DirectoryExists(redendir[wrn]) then
       CreateDir(redendir[wrn] );
   end;
end;

function getnewpictimestamp(cam:integer):int64;

begin
  result:={startup + }beeldcounter[cam];
  inc(beeldcounter[cam]);
end;

procedure loadnewstylebmp(name: string;bmp:tbaseimage;meta:TBasicOverlay; context:TBasisPictureContextObject);
var
  Stream: TStream;
  b : boolean;
begin
 try
  if fileexists(name) then
    begin
  Stream := TFileStream.Create(name, fmOpenRead);
  try
    bmp.loadfromstream(Stream);
    b:=false;
    stream.Read(b,1);
    if b then
      begin
        meta.LoadFromStream(Stream);
        stream.Read(b,1);
        if b and assigned(context) then
          context.LoadFromStream(stream);
      end
   else
    begin
      bmp.clear;
      meta.clear;
    end;
   finally
    Stream.Free;
  end
  end
  else
     begin
      bmp.clear;
      meta.clear;
    end;
 except
  on e: exception do
    begin
      bmp.clear;
      meta.clear;
    end;
  end;
end;


procedure savenewstylebmp(name: string;bmp:tbaseimage;meta:TBasicOverlay; context:TBasisPictureContextObject);
var
  Stream: TStream;
  b : boolean;
begin
  Stream := TFileStream.Create(name, fmCreate);
  try
    bmp.SaveToStream(Stream);
    b:=assigned(meta);
    stream.write(b,1);
    if b then
      meta.SaveToStream(Stream);
    b:=assigned(context);
    stream.write(b,1);
    if b then
      context.SaveToStream(stream);
  finally
    Stream.Free;
  end;
end;

function getdefaultdir : string;
begin
 result:=redendir[Product_ok];
end;

procedure directsavebeeld(Red:TReden;beeld:tbaseimage;meta:TBasicOverlay;cam:integer=1);
var s,s2  : String;
begin
  s2:=inttostr(getnewpictimestamp(cam));
  s:=redendir[red] +'/' +  'raw'+ '_' +
               StringOfChar('0', 19 - Length(s2)) +s2+
               '_' + FormatDateTime('yymmddhhnnss', Now);
  savenewstylebmp(s+'.bmp',beeld,meta,nil);
end;


{ TVersionedPictureContextObject }

procedure TVersionedPictureContextObject.LoadFromStream(Stream: TStream);
var w : word;
    x : array[0..50] of char;
begin
   inherited;
   redenen:=[];
   if isok then
     stream.Read(version,sizeof(integer));
   if version>1 then
     begin
       stream.read(w,sizeof(w));
       if w>sizeof(tredenset) then
         begin
           stream.read(redenen,sizeof(tredenset));
           stream.read(x,w-sizeof(tredenset));
         end
       else
         stream.read(redenen,w);
     end;
end;

procedure TVersionedPictureContextObject.SaveToStream(Stream: TStream);

var w : word;

begin
  inherited;
  version:=HistoryVersion;
  stream.write(version,sizeof(integer));
  w:=sizeof(tredenset);
  if version>1 then
    begin
      stream.Write(w,sizeof(w));
      stream.write(redenen,sizeof(tredenset));
    end;
end;

end.
