unit candelautils;

interface
{$i vwrdefines.inc}
Uses  classes,grids, forms, types, Windows, controls, graphics, comctrls, buttons, stdctrls, Sysutils, registry,

      baseoverlay, candtype, baseimage,ctypes;

const
   clMygreen= TColor($C0ECC0);
   clMyblue = TColor($FFB0B0);
   clMyYellow= TColor($A0FFFF);
   cloranjegeel = tcolor($00C0FF);
   clMyOrange   = tcolor($0080FF);
   clpastelblauw = tcolor($FF8000);
   clstdcolor    = tcolor($F8E0E0);
   dateisoformatnous= 'yyyy-mm-dd hh:nn:ss';
   dateisoformat= 'yyyy-mm-dd hh:nn:ss:zzz';
   //tcolor($FFEEEF); //  RGB(239, 238, 255);

Type
      TButtonDynArray       = Array of TButton;
      TSpeedButtonDynArray  = Array of TSpeedButton;
      TCheckboxDynArray     = Array of TCheckbox;
//
// Alias some commonly used type to keep initial D2009 modifications down.

   PBByte = candtype.pbbyte;

function  appendfile(var datafile : Textfile;filename:string):boolean; overload;
function  appendfile(var datafile:file;filename:string):boolean; overload;

procedure starttimer(var tmr:int64);
function  endtimer(tmr : int64):string;
function  endtimerms(tmr : int64):int64;
function  endtimerus(tmr : int64):int64;

function  endtimermssingle(tmr : int64):single;
function  endtimerwithresult(tmr : int64;var v:int64):string;
function  endtimerwithresultms(tmr : int64;var v:int64):integer;
function  endtimerwithresultmsSingle(tmr : int64;var v:int64):single;
function  incrementbeeldcounter:int64;
function  getfreq:int64; {$ifndef ver150}inline;{$endif}
function  beeldcounter : int64;
procedure dosedsleep(sleeptijd:int64);
function  debugpanels(t:twincontrol;s:string):string;
procedure checknr(err: integer; plek: string);
procedure zapcolor(t:twincontrol;col:TColorRef);

procedure WriteStringToIniFile(IniFileName, Section, Key, Value: string);
procedure WriteIntegerToIniFile(IniFileName, Section, Key: string; Value:Integer);
procedure WriteBooleanToIniFile(IniFileName, Section, Key: string; Value:Boolean);
{$ifdef havedisplayimage}
procedure drawonbuf(CameraImage:TBW8ImageDisplay;CameraImageOverlay:TMetaFile);
{$endif}
procedure hidetabs(p:tpagecontrol;tabs:array of string);     // not working
function  findspeedbutton(const buts:array of tspeedbutton): integer; overload;
function  findspeedbutton(const buts:array of tspeedbutton;obj:TSpeedButton): integer; overload;
function  findcheckbox(const buts:array of tcheckbox;obj:Tcheckbox): integer;
function  findbutton(const buts:TButtonDynArray;obj:Tbutton): integer;
function  checkedradiobox(const radios:array of TRadioButton): integer;
Type
  TLoadSave= (eventload,eventsave);
  TLoadSaveElement = procedure (name:string;ls:TLoadSave) of object;
  TLoadSaveContext = class
                      onload :TLoadSaveElement;
                      fdefault:integer;
                      fwriteenabled : boolean;
                      fprefix : String;
                      constructor create (onload:TLoadSaveelement;def:integer;writeenabled:boolean=true;prefix:String='');
                      end;

  TImageZoomData  = record
                       oldpanx,
                       oldpany,
                       zoomx,
                       zoomy : single;
                       scrollbars : boolean;
                      end;

procedure ClearGrid(aStringGrid: TStringGrid);
function  hexstr(val : longint;cnt : byte) : shortstring;
{$ifdef has_unicodestring}
function  hexbuf(p:pchar;cnt : byte) : ansistring;overload;
{$endif}
function  hexbuf(p:pansichar;cnt : byte) : ansistring;overload;

function  getformatsettings:TFormatSettings;

procedure addints(p1,p2:PIntegerArray;nr :integer;first,later:integer);overload;
procedure addints(p1,p2:PIntegerArray;nr :integer);overload;
procedure correctints(p1:PIntegerArray;nr,first,later :integer);
procedure GridClean(Sender: TStringGrid);
function  GetExeDir:string;
function  GetExeName:string;
function  getcreationtime(fn:string;var v: TDateTime):Boolean;
function  intToBin(Value: Longint; Digits:integer): string;
function  getheapstatusstring:string;
function  convertlocaleindependant (const astr:string; var s : single):boolean;
procedure blastcopy (fromn,ton:string);
procedure colorinitstringgrid(t:tstringgrid;c:tcolor=clwhite);

//procedure lognamerotatetime(tmr:TDateTime;logname:string;logpref:string;nrlogs:integer);
var Englishformatsettings :   tformatsettings;
    Dutchformatsettings   :   tformatsettings;

                                   // 0,1,2,3,4   5    6  7    8   9
const machten : array[0..31] of cardinal=(1,2,4,8,$10,$20,$40,$80,$100,$200,$400,$800,$1000,$2000,$4000,$8000,
                                          $10000,$20000,$40000,$80000,$100000,$200000,$400000,$800000,
                                          $1000000,$2000000,$4000000,$8000000,$10000000,$20000000,$40000000,$80000000);

function splitstring(const s:string;c:char):TStringList;

procedure turnoffanimation;
function allocatealigned(nrbytes,nralign:integer;var pold:pchar):pchar;  // nralign=power of two!

procedure Scrollbarseteventlessposition(scr:TScrollbar;def:integer);
procedure SingleInstance(MutexName: String; MainFormClassName: String; MainFormCaptionPart: String);

Function RPosEX(C:ansichar;const S : AnsiString;offs:cardinal):Integer; overload;
Function RPos(c:ansichar;const S : AnsiString):Integer; overload;

implementation

Uses extctrls,inifiles{$ifdef havecreatetime},jclfileutils{$endif},StrUtils;

function splitstring(const s:string;c:char):TStringList;

var i,i2,j : integer;
begin
  result:=TStringlist.create;
  i:=0;
  repeat
    j:=PosEx(c,s,i+1);
    i2:=j;
    if i2=0 then i2:=length(s)+1;
    result.add(copy(s,i+1,i2-i-1));
    i:=j;
  until j=0;
end;

var  sExePath,sExeName : string;

{$ifdef havecreatetime}
function GetFileInformation(const FileName: string; out FileInfo: TSearchRec): Boolean;
begin
  Result := FindFirst(FileName, faAnyFile, FileInfo) = 0;
  if Result then
    SysUtils.FindClose(FileInfo);
end;

function GetFileInformation2(const FileName: string): TSearchRec;
begin
  if not GetFileInformation(FileName, Result) then
    RaiseLastOSError;
end;

function GetFileCreation(const FileName: string): TFileTime;
begin
   Result := GetFileInformation2(FileName).FindData.ftCreationTime;
end;
{$endif}
var freq        : int64;
    startuptime : int64;
    volgnummer  : cardinal;

procedure starttimer(var tmr:int64);
begin
 queryperformancecounter(tmr);
end;

function  endtimer(tmr : int64):string;
var millisec: Single;
    time2:int64;
begin
  QueryPerformanceCounter(time2);
  millisec := ((time2-tmr)*1000) / getfreq;
  Str(millisec:1:1,result);
end;

function  endtimerwithresult(tmr : int64;var v:int64):string;
var millisec: Single;
    time2:int64;
begin
  QueryPerformanceCounter(time2);
  queryperformancefrequency(freq);
  millisec := ((time2-tmr)*1000) / getfreq;
  Str(millisec:1:1,result);
  v:=time2;
end;

function  endtimerms(tmr : int64):int64;
var     time2:int64;
begin
  QueryPerformanceCounter(time2);
  result:= (((time2-tmr)*1000) div  getfreq) ;
end;

function  endtimerus(tmr : int64):int64;
var     time2:int64;
begin
  QueryPerformanceCounter(time2);
  result:= (((time2-tmr)*1000000) div  getfreq) ;
end;


function  endtimermssingle(tmr : int64):single;
var     time2:int64;
begin
  QueryPerformanceCounter(time2);
  result:= ((time2-tmr)*1000) / getfreq;
end;

function  incrementbeeldcounter:int64;
begin
  inc(volgnummer);
  result:=startuptime+volgnummer;
end;
function  beeldcounter : int64;
begin
  result:=startuptime+volgnummer;
end;

function  getfreq:int64;

begin
  queryperformancefrequency(result);
end;

procedure dosedsleep(sleeptijd:int64);

var huidigetijd,stoptijd : int64;

begin
              QueryPerformanceCounter(huidigetijd);
              stoptijd := huidigetijd + (sleeptijd*getfreq) div 1000;  // stoptijd in ms

              Application.ProcessMessages; // Ook bediening mogelijk maken bij 0ms vertraging
              while huidigetijd<stoptijd do
                begin
                  // Zorg dat de userinterface tijdens de wachttijd nog bediend kan worden.
                  Application.ProcessMessages;
                  sleep(10);                    // Vermijd busy waiting.
                  QueryPerformanceCounter(huidigetijd);
                end;
end;

procedure checknr(err: integer; plek: string);
begin
 if err<>0 {FCE_NOERROR }then
   raise Exception.create(' error '+inttostr(err)+' in '+plek);;
end;

procedure zapcolor(t:twincontrol;col:tcolorref);
 var i : integer;

begin
  if t is  tpanel then
    begin
      tpanel(t).parentcolor:=false;
      tpanel(t).parentbackground:=false;
      tpanel(t).color:=col;
     end;
  if t is  tform then
    begin
//      tform(t).parentcolor:=false;
//      tform(t).parentbackground:=false;
      tform(t).color:=col;
     end;
  for i:=0 to t.ControlCount-1  do
    begin
     if t.Controls[i] is tpanel then
      begin
       tpanel(t).parentcolor:=false;
       tpanel(t).parentbackground:=false;
       tpanel(t.controls[i]).color:=col;
      end;
     if t.Controls[i] is tgroupbox then
      begin
       tgroupbox(t).parentcolor:=false;
       tgroupbox(t).parentbackground:=false;
       tgroupbox(t.controls[i]).color:=col;
      end;
     if t.Controls[i] is twincontrol then
       zapcolor(twincontrol(t.controls[i]),col);
  
    end;
end;

function debugpanels(t:twincontrol;s:string):string;
 var i : integer;

begin
  result:='';
  for i:=0 to t.ControlCount-1  do
    begin
     if t.Controls[i] is twincontrol then
       result:=result+debugpanels(twincontrol(t.controls[i]),'');
    end;
  if t is  tpanel then
    result:=result+tpanel(t).Name + ' '+inttostr(t.left)+' '+inttostr(t.top)+ ' ' +inttostr(t.width)+' '+inttostr(t.height)+' '#13#10;
end;


procedure WriteStringToIniFile(IniFileName, Section, Key, Value: string);
var

  IniFile: TIniFile;
begin
  IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + IniFileName);
  try
    IniFile.WriteString(Section, Key, Value);
  finally
    FreeAndNil(IniFile);
  end;
end;

procedure WriteIntegerToIniFile(IniFileName, Section, Key: string; Value:Integer);
var
  IniFile: TIniFile;
begin
  IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + IniFileName);
  try
    IniFile.WriteInteger(Section, Key, Value);
  finally
    FreeAndNil(IniFile);
  end;
end;

procedure WriteBooleanToIniFile(IniFileName, Section, Key: string; Value:Boolean);
var
  IniFile: TIniFile;
begin
  IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + IniFileName);
  try
    IniFile.WriteBool(Section, Key, Value);
  finally
    FreeAndNil(IniFile);
  end;
end;

{$ifdef havedisplayimage}
procedure drawonbuf(CameraImage:TBW8ImageDisplay;CameraImageOverlay:TMetaFile);
var
  C: TCanvas;
  PanX, PanY, ZoomX, ZoomY : Single;
  Rect : TRect; //(Left, Top, Right, Bottom: Integer);

begin
    PanX := CameraImage.PanX;
    PanY := CameraImage.PanY;
    ZoomX := CameraImage.ZoomX;
    ZoomY := CameraImage.ZoomY;

  C := TCanvas.Create;
  try
    C.Handle := GetDC( CameraImage.Handle );

    Rect.Left := Round( ZoomX * PanX );
    Rect.Top := Round( ZoomY * PanY );
    Rect.Right := Round( ZoomX * (CameraImage.ImageWidth + PanX) );
    Rect.Bottom := Round( ZoomY * (CameraImage.ImageHeight + PanY) );

    C.StretchDraw(Rect, CameraImageOverlay);
  finally
    ReleaseDC( CameraImage.Handle, C.Handle );
    C.Free;
  end;
end;
{$endif}

procedure hidetabs(p:tpagecontrol;tabs:array of string);

var i,j,k,l : integer;
    pgs : array of ttabsheet;
begin
  setlength(pgs,length(tabs));
  k:=0;
  l:=length(tabs);
  for i:=0 to p.PageCount-1 do
    begin
      j:=0;
      while j<l do
        begin
          if p.Pages[i].Caption=tabs[j] then
            begin
              pgs[k]:=p.pages[i];
              inc(k);
              j:=l
            end;
          inc(j);
        end;
    end;

  for i:=0 to k-1 do
    p.RemoveControl(pgs[i]);


//  pgs[i].TabVisible:=false;
end;

function findspeedbutton(const buts:array of tspeedbutton): integer;
var i,len : integer;
begin
  i:=0; len:=length(buts);
  while (i<len) and not (buts[i].Down) do inc(i);
  if i=len then i:=0;
  result:=i;
end;

function findspeedbutton(const buts:array of tspeedbutton;obj:TSpeedButton): integer; overload;
var i,len : integer;
begin
  i:=0; len:=length(buts);
  while (i<len) and not (buts[i]=obj) do inc(i);
  if i=len then i:=0;
  result:=i;
end;

function findcheckbox(const buts:array of tcheckbox;obj:Tcheckbox): integer;
var i,len : integer;
begin
  i:=0; len:=length(buts);
  while (i<len) and not (buts[i]=obj) do inc(i);
  if i=len then i:=0;
  result:=i;
end;

function findbutton(const buts:TButtonDynArray ;obj:Tbutton): integer;
var i,len : integer;
begin
  i:=0; len:=length(buts);
  while (i<len) and not (buts[i]=obj) do inc(i);
  if i=len then i:=0;
  result:=i;
end;

{ TLoadSaveContext }

constructor TLoadSaveContext.create(onload: TLoadSaveelement; def: integer;  writeenabled: boolean=true;prefix:string='');
begin
  self.onload:=onload;
  self.fdefault:=def;
  self.fwriteenabled:=writeenabled;
  fprefix:=prefix;
end;

function  endtimerwithresultms(tmr : int64;var v:int64):integer;
var
    time2:int64;
begin
  QueryPerformanceCounter(time2);
  result := ((time2-tmr)*1000) div getfreq;
  v:=time2;
end;

function  endtimerwithresultmsSingle(tmr : int64;var v:int64):single;
var
    time2:int64;
begin
  QueryPerformanceCounter(time2);
  result := ((time2-tmr)*1000) / getfreq;
  v:=time2;
end;

procedure ClearGrid(aStringGrid: TStringGrid);
var
  l_loop : integer;
begin
  LockWindowUpdate( aStringGrid.Handle );
  try
    for l_loop := 1 to aStringGrid.RowCount - 1 do
      aStringGrid.Rows[ l_loop ].Clear;
  finally
    LockWindowUpdate( 0 );
  end;
end;

const
  HexTbl : array[0..15] of ansichar='0123456789ABCDEF';

function hexstr(val : longint;cnt : byte) : shortstring;
var
  i : longint;
begin
  hexstr[0]:=ansichar(cnt);
  for i:=cnt downto 1 do
   begin
     hexstr[i]:=hextbl[val and $f];
     val:=val shr 4;
   end;
end;

{$ifdef has_unicodestring}
function hexbuf(p:pchar;cnt : byte) : ansistring;
var
  i : longint;
begin
  if cnt<>1 then
   i:=cnt*3-1
  else
   i:=cnt*2;
  setlength(result,i);
  for i:=0 to cnt-1 do
   begin
     result[1+i*3]:=hextbl[ord(p[i]) shr 4];
     result[1+i*3+1]:=hextbl[ord(p[i]) and $f];
     if i<>(cnt-1) then
       result[1+i*3+2]:=' ';
   end;
end;
{$endif}

function hexbuf(p:pansichar;cnt : byte) : ansistring;
var
  i : longint;
begin
  if cnt<>1 then
   i:=cnt*3-1
  else
   i:=cnt*2;
  setlength(result,i);
  for i:=0 to cnt-1 do
   begin
     result[1+i*3]:=hextbl[ord(p[i]) shr 4];
     result[1+i*3+1]:=hextbl[ord(p[i]) and $f];
     if i<>(cnt-1) then
       result[1+i*3+2]:=' ';
   end;
end;

function getformatsettings:TFormatSettings;
var i : integer;
begin
  result.CurrencyFormat:=currencyformat;
  result.NegCurrFormat:=NegCurrFormat;
  result.ThousandSeparator:=ThousandSeparator;
  result.DecimalSeparator:=DecimalSeparator;
  result.CurrencyDecimals:=CurrencyDecimals;
  Result.DateSeparator:=Dateseparator;
  result.TimeSeparator:=TimeSeparator;
  result.ListSeparator:=ListSeparator;
  result.CurrencyString:=CurrencyString;
  result.ShortDateFormat:=ShortDateFormat;
  result.LongDateFormat:=LongDateFormat;
  result.TimeAMString:=TimeAMString;
  result.TimePMString:=TimePMString;
  result.ShortTimeFormat:=ShortTimeFormat;
  result.LongTimeFormat:=LongTimeFormat;
  for i:=1 to 12 do
    begin
      result.ShortMonthNames[i]:=shortmonthnames[i];
      result.LongMonthNames[i]:=longmonthnames[i];
    end;
  for i:=1 to 7 do
    begin
      result.ShortDayNames[i]:=shortDaynames[i];
      result.LongDayNames[i]:=longDaynames[i];
    end;
  result.TwoDigitYearCenturyWindow:=TwoDigitYearCenturyWindow;
end;


function checkedradiobox(const radios:array of TRadioButton): integer;
var i,len : integer;
begin
  i:=0; len:=length(radios);
  while (i<len) and not (radios[i].checked) do inc(i);
  if i=len then i:=0;
  result:=i;
end;



{$optimization on}   {$R-}
procedure addints(p1,p2:PIntegerArray;nr :integer);

var p3:PIntegerArray;

begin
  p3:=@p1[nr];
  while (ptrint(p1)<ptrint(p3)) do
   begin
     inc(p1[0],p2[0]);
     inc(pinteger(p1));
     inc(pinteger(p2));
   end;
end;

procedure addints(p1,p2:PIntegerArray;nr :integer;first,later:integer);

var p3:PIntegerArray;
    i : integer;
begin
  addints(p1,p2,nr);
  if first>0 then
    begin
      p3:=@p1[first];
      for i:=0 to first -1 do
        inc(p3[0],p1[i]);
    end;
  if later<(nr-1) then
    begin
      p3:=@p1[later];
      for i:=later+1 to nr-1 do
        inc(p3[0],p1[i]);
    end;
end;


procedure correctints(p1:PIntegerArray;nr,first,later :integer);

var p3:PIntegerArray;
    i : integer;
begin
  if first>0 then
    begin
      p3:=@p1[first];
      for i:=0 to first -1 do
        inc(p3[0],p1[i]);
    end;
  if later<(nr-1) then
    begin
      p3:=@p1[later];
      for i:=later+1 to nr-1 do
        inc(p3[0],p1[i]);
    end;
end;


procedure GridClean(Sender: TStringGrid);
var hGridRect: TGridRect;
begin
   hGridRect.Top := -1;
   hGridRect.Left := -1;
   hGridRect.Right := -1;
   hGridRect.Bottom := -1;
   sender.Selection := hGridRect;
end;

function getexedir:string;
begin
 result:=sExePath;
end;

function  GetExeName:string;
begin
 result:=sExeName;
end;

function FileGetSize(const FileName: string): Int64;
 var
  SearchRec: TSearchRec;
  OldMode: Cardinal;
  Size: TULargeInteger;
begin
  Result := -1;
  OldMode := SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    if FindFirst(FileName, faAnyFile, SearchRec) = 0 then
    begin
      Size.LowPart := SearchRec.FindData.nFileSizeLow;
      Size.HighPart := SearchRec.FindData.nFileSizeHigh;
      Result := Size.QuadPart;
      SysUtils.FindClose(SearchRec);
    end;
  finally
    SetErrorMode(OldMode);
  end;
end;


function filetimetodatetime(filetime:TFileTime):tdatetime;
var
   LocalFileTime: TFileTime;
   SystemTime: TSystemTime;
begin
   FileTimeToLocalFileTime(FileTime, LocalFileTime) ;
   FileTimeToSystemTime(LocalFileTime, SystemTime) ;
   Result := SystemTimeToDateTime(SystemTime) ;
end;
function filetimetostring(filetime:tfiletime):string;
begin
  result:=DateTimeToStr(filetimetodatetime(filetime));
end;

function GetFileInformation(const FileName: string; out FileInfo: TSearchRec): Boolean;
begin
  Result := FindFirst(FileName, faAnyFile, FileInfo) = 0;
  if Result then
    SysUtils.FindClose(FileInfo);
end;

function getbcreationtime(fn:string;var v: TDateTime):Boolean;
var fl:TSearchRec;
begin
  result:=GetFileInformation(fn,fl);
  if result then
    v:=filetimetodatetime(fl.FindData.ftCreationTime);
end;

function getcreationtime(fn:string;var v: TDateTime):Boolean;

begin
  v:=0;
  result:=getbcreationtime(fn,v)
end;

function intToBin(Value: Longint; Digits:integer): string;
var p,p2 : pchar;
  i : integer;
begin
  result:='';
  if digits<=0 then exit;
  setlength(result,digits);
  p:=pchar(pointer(@result[digits]));
  p2:=pchar(pointer(@result[1]));
  // typecasts because we want to keep intto* delphi compat and take an integer
  while (p>=p2) and (cardinal(value)>0) do
    begin
       p^:=chr(48+(cardinal(value) and 1));
       value:=cardinal(value) shr 1;
       dec(p);
    end;
  digits:=p-p2+1;
  if digits>0 then
    begin
      for i := 1 to digits  do
        result[i]:=#48;
    end;
end;

function appendfile(var datafile : Textfile;filename:string):boolean;
var b:boolean;
begin
  b:=fileexists(filename);
  AssignFile(DataFile, FileName);
  if b then
    Append(DataFile)    //voeg toe
  else
    rewrite(datafile);
  result:=b;
end;

function appendfile(var datafile : file;filename:string):boolean;
var b:boolean;
begin
  b:=fileexists(filename);
  AssignFile(DataFile, FileName);
  if b then
    begin
    reset(DataFile,1);    //voeg toe
    seek(datafile,filesize(datafile));
    end
  else
    rewrite(datafile);
  result:=b;
end;

function getheapstatusstring:string;
var t : THeapstatus;
begin
   t:=GetHeapStatus;
   result:=
    'TotalAddrSpace   '+inttostr(t.TotalAddrSpace )+' '+
    'TotalUncommitted '+inttostr(t.TotalUncommitted)+' '+
    'TotalCommitted   '+inttostr(t.TotalCommitted)+' '+
    'TotalAllocated   '+inttostr(t.TotalAllocated)+' '+
    'TotalFree        '+inttostr(t.TotalFree)+' '+
    'FreeSmall        '+inttostr(t.FreeSmall)+' '+
    'FreeBig          '+inttostr(t.FreeBig)+' '+
    'Unused           '+inttostr(t.Unused)+' '+
    'Overhead         '+inttostr(t.Overhead)+' '+
    'HeapErrorCode    '+inttostr(t.HeapErrorCode);
end;

function convertlocaleindependant (const astr:string; var s : single):boolean;
begin
  s:=strtofloatdef(astr,-1,Dutchformatsettings);
  if s=-1 then
    s:=strtofloatdef(astr,-1,Englishformatsettings);
  result:=s=-1;
end;

procedure turnoffanimation;
var
   TheReg: TRegistry;
   KeyName: String;
   ValueStr: String;
begin
try
 TheReg := TRegistry.Create;
   try
      TheReg.RootKey := HKEY_CURRENT_USER;
      KeyName := 'Control Panel\Desktop\WindowMetrics';
      if TheReg.OpenKey(KeyName, true) then
      begin
         TheReg.WriteInteger('MinAnimate',0);
         TheReg.CloseKey;
      end;
   finally
      TheReg.Free;
   end;
 except on e:exception do ; end;
end;

procedure colorinitstringgrid(t:tstringgrid;c:tcolor=clwhite);

var x,y : integer;
begin
  for x:=0 to t.colcount-1 do
    for y:=0 to t.rowcount-1 do
     t.Objects[x,y]:=tobject(c);
end;

procedure blastcopy (fromn,ton:string);
var f1,f2 : file;
    buf : array[0..32767] of byte;
    res : Integer;
    s:string;
begin
 if not fileexists(ton) then
   begin
     s:=ExtractFilePath(ton);
     if not directoryexists(s) then
       exit;
     assignfile(f1,fromn);
     reset(f1,1);
     assignfile(f2,ton);
     rewrite(f2,1);
     repeat
       blockread(f1,buf,sizeof(buf),res);
       blockwrite(f2,buf,res);
     until res<>sizeof(buf);
     closefile(f1);
     closefile(f2);
   end;
end;

function allocatealigned(nrbytes,nralign:integer;var pold:pchar):pchar;

var n,n2:ptruint;
begin
  getmem(pold,nrbytes+nralign);
  n:=(nralign-(ptruint(pold) and (nralign-1))) and (nralign-1);   // second "AND" is to transform 1..nralign to 0..nralign-1
  result:=@pold[n];
end;

procedure Scrollbarseteventlessposition(scr:TScrollbar;def:integer);

var oldevent : TNotifyEvent;

begin
  oldevent:=scr.OnChange;
  scr.onchange:=nil;
  scr.Position:=def;
  scr.OnChange:=oldevent;
end;

Function RPosEX(C:ansichar;const S : AnsiString;offs:cardinal):Integer; overload;

var I   : SizeUInt;
    p,p2: pAnsiChar;

Begin
 I:=Length(S);
 If (I<>0) and (offs<=i) Then
   begin
     p:=@s[offs];
     p2:=@s[1];
     while (p2<=p) and (p^<>c) do dec(p);
     result:=(p-p2)+1;
   end
  else
    result:=0;
End;

Function RPos(c:ansichar;const S : AnsiString):Integer; overload;

var I   : Integer;
    p,p2: pAnsiChar;

Begin
 I:=Length(S);
 If I<>0 Then
   begin
     p:=@s[i];
     p2:=@s[1];
     while (p2<=p) and (p^<>c) do dec(p);
     i:=p-p2+1;
   end;
  result:=i;
End;

procedure SingleInstance(MutexName: String; MainFormClassName: String; MainFormCaptionPart: String);
var
  MutexHandle : THandle;
begin
  MutexHandle := CreateMutex(nil, True, pchar(MutexName));
  if MutexHandle <> 0 then
  begin
    if GetLastError = ERROR_ALREADY_EXISTS then
    begin
      CloseHandle(MutexHandle);
      //ActivateWindow(MainFormClassName, MainFormCaptionPart);
      Halt;
    end;
  end;
end;

initialization
  sExePath := ExtractFilePath(Application.ExeName);
  sExeName := ChangeFileExt(ExtractFileName(paramstr(0)),'');
  queryperformancefrequency(freq);
  startuptime:=trunc((now-encodedate(2000,1,1))*3600.0) shl 32;
  volgnummer:=0;
  Englishformatsettings:=getformatsettings;
  Englishformatsettings.ThousandSeparator:=',';
  Englishformatsettings.DecimalSeparator:='.';
  Dutchformatsettings:=getformatsettings;
  Dutchformatsettings.ThousandSeparator:='.';
  Dutchformatsettings.DecimalSeparator:=',';
end.
