unit glblitfrm;

interface
 {$i vwrdefines.inc}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Extctrls, StdCtrls, Menus,

  basehistory,baseoverlay,baseimage,switchfrm,glblitter,globaldefs,candelautils{$ifdef usexml},laz_xmlcfg{$endif};

type
  TTimings = ( timebeeld,timeflushoverlay,timerefresh);

  TGLImageFrame= class(TSwitchFrame)
    picpanel: TPanel;
    leftpanel: TPanel;
    bottompanel: TPanel;
    Scroffsy: TScrollBar;                       // offset.position 0..999 meaning  0/1000.0  till 999/1000.0 offset.
    Scroffsx: TScrollBar;
    Panel1: TPanel;
    scrzoom: TScrollBar;                        // zoom (1/8 ..8) = (2ln(zoom)+3) *100.0           +3 comes from 1/8 = 2^-3
    buzoomplus: TButton;
    buzoomminus: TButton;
    budetailminus: TButton;
    dudetailplus: TButton;
    lbdetail: TLabel;
    buStandaard: TButton;
    procedure ScroffsyChange(Sender: TObject);
    procedure ScroffsxChange(Sender: TObject);
    procedure picpanelResize(Sender: TObject);
    procedure FrameResize(Sender: TObject);
    procedure buzoomminusClick(Sender: TObject);
    procedure buzoomplusClick(Sender: TObject);
    procedure newzoom(z,z2:single);
    procedure scrzoomChange(Sender: TObject);
    procedure dudetailplusClick(Sender: TObject);
    procedure budetailminusClick(Sender: TObject);
    procedure buStandaardClick(Sender: TObject);
  private
    glblit: TGLBlitter;
    fPopupMenu : TPopupMenu;
//    fPopupZoomMenu : TPopupMenu;
    fEnableScrollBars : boolean;
    faspectoverride : boolean;
    fbwbuffer : TBaseImage;
    foverlaydata : toverlaydata;
    fdetaillevel : integer;
    fhuddata : TOverlaylayerData;
    fontsizecache : tfontsizecache; // array[0..nrOverlayLayers] of integer;
    fdefaultmode : Integer;
    fmirrorhud   : boolean;
    staterefresh : boolean;
    Fselectableregion: boolean;
    fpersistent : boolean;
    procedure MnuZoomInClick(Sender: TObject);
    procedure MnuTrueScaleClick(Sender: TObject);
    procedure MnuZoomfitClick(Sender: TObject);
    procedure MnuZoomOutClick(Sender: TObject);
    procedure MnuScrollBarsClick(Sender: TObject);
    procedure WisPopupMenuZoomVinkje;
    procedure putvinkje(cls:integer;item:integer);
    procedure putvinkjeSender(cls:integer;sender:tobject);
    procedure putvinkjeglobal(cls:integer;b:boolean);
    procedure popupcreate;
    procedure SetEnableScrollBars(b:boolean);
    procedure mouseclickoncanvas(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    function getoverlay: TOverlaylayerdata;
    function getoverlayfontsize(ind: integer): integer;
    procedure setoverlayfontsize(ind: integer; const Value: integer);
    procedure Setselectableregion(const Value: boolean);
    function getviewableheight: integer;
   public
    fTimings : array[  TTimings] of integer;
    ftimers  : array[  TTimings] of int64;
    procedure setzoomoffs(zx,zy,ox,oy:single);
    {$ifdef usexml}
    procedure Loadfromxml(xml:TXmlConfig;key:string); override;
    procedure savetoxml(xml:TXmlConfig;key:string); override;
    {$endif}
    procedure attach(p:array of Tperbeeld); override;
    procedure detach(perbeeld:array of tperbeeld);  override;
    procedure newframe(cameranr:integer;perbeeld:tperbeeld); overload;override;
    procedure newframe(cameranr: integer; beeld: TBaseImage); overload;
    procedure newframebeeld(cameranr:integer;beeld:TBaseImage;meta:toverlaydata);
    procedure loadimage(name:string;context:TBasisPictureContextObject);
    procedure drawtimings(x,y:integer;yincr:integer;lastoverall:integer);
    procedure hudprepare(img:tbaseimage);
    Procedure Frameinit(prn : Tobject;metingen:TMetingenHierarchie;context:TObject=nil); override;
    procedure FrameClose; override;
    procedure clear;
    procedure clearoverlay;
    procedure test(i:integer);
    procedure focusblob(nr: integer);
    procedure setoffsx(ox:single);
    procedure setoffsy(oy:single);
    procedure setzoomx(zx:single);
    procedure setzoomy(zy:single);
    procedure setscale(aspect:boolean);
    procedure redrawupdate; deprecated; // Not really deprecated, but we want to keep track of this.

    property bwbuffer : TBaseImage read fbwbuffer;
    property overlay : TOverlaydata read foverlaydata;
    property hud : TOverlaylayerdata read getoverlay;
    property overlayfontsize[ind:integer]:integer read getoverlayfontsize write setoverlayfontsize;
    property defaultmode :integer read fdefaultmode write fdefaultmode;
    property mirrorhud  :boolean read fmirrorhud write fmirrorhud;
    property selectableregion : boolean read Fselectableregion write Setselectableregion;
    property persistent : boolean read fpersistent write fpersistent;
    property viewableheight : integer read getviewableheight;
    { Public declarations }
  end;

var
  GLImageFrame: TGLImageFrame;

implementation

{$R *.dfm}

const powers2 : array[0..6] of single= (1/8,1/4,1/2,1,2,4,8);

function roundpower2(v:single):single;
var x,lastdif:single;
    n,n2 : integer;
begin
 n2:=0; lastdif:=1000;
 for n:=0 to 6 do
   begin
     x:=abs(v-powers2[n]);
     if x<lastdif then
       begin
         lastdif:=x;
         n2:=n;
       end;
   end;
 result:=powers2[n2];
end;

// 1/16 < zoom < 16    -> perform ln2 for exponential behaviour
// -4  < ln2(zoom) < 4 -> add 4 to make it possitive
// 0  < ln2(zoom)+4 < 8  ->  multiple with 12.5 to bring it in range 0 .. 100 for scroller

const aftel = 4; // 2^4=16, maximale zoom
function zoom2position (z:single):integer;
begin
  result:=round(12.5 *((ln(z)/ln(2))+aftel));
end;

function position2zoom(z:integer):single;
begin
  result:=exp(((z/12.5)-aftel)*ln(2));
end;

Const
      tagzoomin       = 1;
      tagtruescale    = 2;
      tagzoomout      = 3;
      tagzoomscroll   = 4;
      tagzoomfit      = 5;

{ TGLBlitFrame }

procedure TGLImageFrame.attach(p: array of Tperbeeld);
begin
 {$ifdef blitdebug}
  log.logline(srcdebug,'before frame attach',catwarning);
  {$endif}
  self.parent:=prnt;

  popupcreate;
//  popupmenu:=fPopupMenu;
//  PopupList.Add(fPopupMenu);
//  PopupList.Add(fPopupZoomMenu);
  picpanelResize(nil);
  if not assigned(glblit) then
    begin
      glblit:=TGLBlitter.createfrompanel(picpanel);
      glblit.fontsizecache:=fontsizecache;
      glblit.OnMouseDown:=mouseclickoncanvas;
      zapcolor(self,globalcolor);
      Scrollbarseteventlessposition(Scroffsy,round(glblit.YOffset*1000.0));
      Scrollbarseteventlessposition(Scroffsx,round(glblit.xOffset*1000.0));
      Scrollbarseteventlessposition(scrzoom,round(zoom2position(glblit.ZoomX)));
      lbdetail.Caption:=inttostr(fdetaillevel);
      glblit.setdetail(fdetaillevel);
      glblit.overlayattach;
    end
  else
    begin
     glblit.attach(picpanel);
     glblit.setdetail(fdetaillevel);
     scrzoom.SetBounds(scrzoom.left,scrzoom.top,picpanel.Width-scrzoom.Left-buzoomplus.Width,scrzoom.height);
     if persistent and (bwbuffer.ImageWidth>0) and (bwbuffer.ImageWidth>0) Then
       begin
         glblit.setoverlays(foverlaydata);
         glblit.LoadPicture(bwbuffer.imageWidth,bwbuffer.imageheight,bwbuffer.rawuntyped,bwbuffer.bpp);
         glblit.flushoverlay;
         glblit.refresh;
      end;
   end;
   lbdetail.Caption:=inttostr(fdetaillevel);
   {$ifdef blitdebug}
   log.logline(srcdebug,'after frame attach',catwarning);
   {$endif}
{  glblit.redrawafterchange;
  sleep(10);}
end;

procedure TGLImageFrame.detach(perbeeld: array of tperbeeld);
begin
  foverlaydata.Clear;
  glblit.detach;
  fhuddata.Clear;
{  RemoveComponent(fpopupmenu);}
   popupmenu:=nil;
   freeandnil(fPopupMenu);
end;

procedure TGLImageFrame.FrameClose;
begin
 {$ifdef dodeallocate}
{   RemoveComponent(fpopupmenu);}
 {$endif}

  freeandnil(fbwbuffer);
  freeandnil(foverlaydata);
  freeandnil(fhuddata);
  if assigned(glblit) then
     glblit.parent:=nil; // just in case.
  freeandnil(glblit);
end;

procedure TGLImageFrame.Frameinit(prn: Tobject;
  metingen: TMetingenHierarchie; context: TObject);

var n : integer;
begin
//  glblit:=TGLBlitter.CreateFromPanel(picpanel);
  for n:=0 to high(fontsizecache) do
    fontsizecache[n]:=32;
  prnt:=twincontrol(prn);
//  popupcreate;
  zapcolor(self,globalcolor);
  fbwbuffer:=Tbaseimage.create;
  foverlaydata:=toverlaydata.create;
  fdetaillevel := nrOverlayLayers;
  scroffsx.Min:=-500;
  scroffsy.Min:=-500;
  fhuddata :=TOverlaylayerData.create;
  staterefresh:=false;
  Fselectableregion:=false;
  fpersistent:=false;
end;

procedure TGLImageFrame.newframe(cameranr: integer; perbeeld: tperbeeld);
begin
  {$ifdef blitdebug}
  log.logline(srcdebug,'entering newframe',catwarning);
  {$endif}
  glblit.setoverlays(perbeeld.canvasbuf);
  glblit.hud.assign(fhuddata);
  if selectableregion then
    glblit.ColorSelection;
  starttimer(ftimers[timebeeld]);
  if persistent Then
    begin
       foverlaydata.assign(perbeeld.canvasbuf);
       bwbuffer.kopieer(perbeeld.hetbeeld);
    end;

  glblit.LoadPicture(perbeeld.hetbeeld.imageWidth,perbeeld.hetbeeld.imageheight,perbeeld.hetbeeld.rawuntyped,perbeeld.hetbeeld.bpp);
  fTimings[timebeeld]:=endtimerus(ftimers[timebeeld]);

  starttimer(ftimers[timeflushoverlay]);
  glblit.flushoverlay;
  fTimings[timeflushoverlay]:=endtimerus(ftimers[timeflushoverlay]);
  starttimer(ftimers[timerefresh]);
  glblit.refresh;
  fTimings[timerefresh]:=endtimerus(ftimers[timerefresh]);
  {$ifdef blitdebug}
  log.logline(srcdebug,'leaving newframe',catwarning);
  {$endif}
end;

procedure TGLImageFrame.newframe(cameranr: integer; beeld: TBaseImage);
begin
 //  glblit.setoverlays(perbeeld.canvasbuf);
 // glblit.hud.assign(fhuddata);
  starttimer(ftimers[timebeeld]);
  glblit.LoadPicture(beeld.imageWidth,beeld.imageheight,beeld.rawuntyped,beeld.bpp);
  fTimings[timebeeld]:=endtimerus(ftimers[timebeeld]);

  starttimer(ftimers[timeflushoverlay]);
  glblit.flushoverlay;
  fTimings[timeflushoverlay]:=endtimerus(ftimers[timeflushoverlay]);
  starttimer(ftimers[timerefresh]);
  glblit.refresh;
  fTimings[timerefresh]:=endtimerus(ftimers[timerefresh]);
end;

procedure TGLImageFrame.newframebeeld(cameranr: integer; beeld: TBaseImage;
  meta: toverlaydata);
begin
  glblit.setoverlays(meta);
  glblit.hud.assign(fhuddata);
  starttimer(ftimers[timebeeld]);
  glblit.LoadPicture(beeld.imageWidth,beeld.imageheight,beeld.rawuntyped,beeld.bpp);
  fTimings[timebeeld]:=endtimerus(ftimers[timebeeld]);

  starttimer(ftimers[timeflushoverlay]);
  glblit.flushoverlay;
  fTimings[timeflushoverlay]:=endtimerus(ftimers[timeflushoverlay]);
  starttimer(ftimers[timerefresh]);
  glblit.refresh;
  fTimings[timerefresh]:=endtimerus(ftimers[timerefresh]);
end;


procedure TGLImageFrame.ScroffsyChange(Sender: TObject);
begin
  glblit.YOffset := TScrollbar(Sender).Position / 1000;
end;

procedure TGLImageFrame.ScroffsxChange(Sender: TObject);
begin
  glblit.Xoffset:= TScrollbar(Sender).Position / 1000;
end;

procedure TGLImageFrame.WisPopupMenuZoomVinkje;
var
  i, j: Integer;
  x,x2 : TMenuitem;
begin
  if not assigned(popupmenu) then exit;

  // Wis een eventueel vinkje
  i:=0;
  while i< PopupMenu.Items.Count do
    begin
      x:=PopupMenu.Items[i];
      if ((x.tag=tagzoomin) or (x.tag= tagzoomout)) then
        begin
          for j:=0 to x.count-1 do
            x.Items[j].Checked := false;
        end;
      if x.tag=tagtruescale then
        x.checked:=false;
      if x.tag=tagzoomfit then
        x.checked:=false;
      inc(i);
    end;
end;

procedure TGLImageFrame.MnuZoomInClick(Sender: TObject);
var
//  s : String;
  Zoomfactor, i, j: Integer;
  z2 : single;
begin
  glblit.setoverrideaspect(false);
  zoomfactor:=TMenuItem(Sender).tag;
  newzoom(zoomfactor,glblit.ZoomX);
  WisPopupMenuZoomVinkje;
  putvinkjeSender(tagzoomin,sender);
end;

procedure TGLImageFrame.MnuScrollBarsClick(Sender: TObject);
begin
 if fEnableScrollBars then
    SetEnableScrollBars( false )
  else
    SetEnableScrollBars( true );
end;

procedure TGLImageFrame.MnuTrueScaleClick(Sender: TObject);
begin
  glblit.setoverrideaspect(false);
//  glblit.set2zoom(1,1);
  glblit.xOffset := 0;   glblit.yOffset := 0;
  newzoom(1,glblit.ZoomX);

  WisPopupMenuZoomVinkje;
  putvinkjeglobal(tagtruescale,true);
end;

procedure TGLImageFrame.popupcreate;
var menuitem,menuitem2 :TMenuItem;
    i : integer;
begin
  fPopupMenu := TPopupMenu.Create(nil); // was self;
  MenuItem := TMenuItem.Create(fpopupmenu);
  MenuItem.Name := 'mnuZoomIn';
  MenuItem.Caption := 'Zoom In';
  fPopupMenu.Items.Add(MenuItem);
  menuitem.Tag:=tagzoomin;
  for i := 2 to 16 do
    begin
//      fPopupZoomMenu:= TPopupMenu.Create(nil);
      MenuItem2 := TMenuItem.Create(fpopupmenu);
      MenuItem2.Name := 'mnui'+IntToStr(i);
      MenuItem2.Caption := IntToStr(i)+':1';
      MenuItem2.OnClick := MnuZoomInClick;
      menuitem.Add(MenuItem2);
      menuitem2.tag:=i;
    end;
  MenuItem := TMenuItem.Create(fpopupmenu);
  MenuItem.Name := 'mnuTrueScale';
  MenuItem.Caption := 'True Scale';
  MenuItem.OnClick := MnuTrueScaleClick;
  fPopupMenu.Items.Add(MenuItem);
  menuitem.Tag:=tagtruescale;

  MenuItem := TMenuItem.Create(fpopupmenu);
  MenuItem.Name := 'mnuZoomFit';
  MenuItem.Caption := 'Zoom Fit';
  MenuItem.OnClick := MnuZoomFitClick;
  fPopupMenu.Items.Add(MenuItem);
  menuitem.Tag:=tagzoomfit;

  MenuItem := TMenuItem.Create(fpopupmenu);
  MenuItem.Name := 'mnuZoomOut';
  MenuItem.Caption := 'Zoom Out';
  fPopupMenu.Items.Add(MenuItem);
  menuitem.Tag:=tagzoomout;
  for i := 2 to 16 do
    begin
//      fPopupZoomMenu:= TPopupMenu.Create(nil);
      MenuItem2 := TMenuItem.Create(fpopupmenu);
      MenuItem2.Name := 'mnuo'+IntToStr(i);
      MenuItem2.Caption := '1:'+IntToStr(i);
      MenuItem2.OnClick := MnuZoomOutClick;
      MenuItem.Add(MenuItem2);
      menuitem2.tag:=i;
    end;
  MenuItem := TMenuItem.Create(fpopupmenu);
  MenuItem.Caption := '-';
  fPopupMenu.Items.Add(MenuItem);
  MenuItem.Tag:=0;
  MenuItem := TMenuItem.Create(fpopupmenu);
  MenuItem.Name := 'mnuScrollBars';
  MenuItem.Caption := 'ScrollBars';
  MenuItem.OnClick := MnuScrollBarsClick;
  fPopupMenu.Items.Add(MenuItem);
  menuitem.Tag:=tagtruescale;
  PopupMenu := fPopupMenu;
end;

procedure TGLImageFrame.MnuZoomOutClick(Sender: TObject);
var
  Zoomfactor, i, j : Integer;
begin
  glblit.setoverrideaspect(false);
  Zoomfactor := TMenuItem(Sender).tag;
  newzoom(1/zoomfactor,glblit.ZoomX);

  WisPopupMenuZoomVinkje;
  putvinkjeSender(tagzoomout,sender);
end;

procedure TGLImageFrame.picpanelResize(Sender: TObject);

var nh,nw : integer;
begin
  panel1.width:=picpanel.width;
  if assigned(glblit) then
    begin
//      if (glblit.height<>picpanel.height) or (glblit.width<>picpanel.width) then
        begin
          glblit.SetBounds(glblit.left,glblit.top,picpanel.width,picpanel.height);
          scrzoom.SetBounds(scrzoom.left,scrzoom.top,picpanel.Width-scrzoom.Left-buzoomplus.Width,scrzoom.height);
          buzoomplus.Left:=picpanel.Width-buzoomplus.Width;
        end;
    end;
end;

procedure TGLImageFrame.FrameResize(Sender: TObject);

var nh,nw :integer;
begin
  nw:=self.width-leftpanel.width;
  nh:=self.Height-bottompanel.height;
  if (picpanel.Width<>nw) and (picpanel.Height<>nh) then
    picpanel.SetBounds(picpanel.left,picpanel.top,nw,nh);
  bottompanel.width:=width;
  leftpanel.Height:=height;
  scroffsx.width:=bottompanel.width-(scroffsy.width);
  scroffsx.Left:=0;
end;

procedure TGLImageFrame.SetEnableScrollBars(b: boolean);
begin
 fEnableScrollBars:=b;
 leftpanel.visible:=b;
 bottompanel.visible:=b;
 putvinkjeglobal(tagzoomscroll,b);
end;

procedure TGLImageFrame.setoffsx(ox: single);
begin
  glblit.set2offs(ox,glblit.YOffset);
  Scrollbarseteventlessposition(Scroffsx,round(glblit.XOffset*1000.0));
end;

procedure TGLImageFrame.setoffsy(oy: single);
begin
  glblit.set2offs(glblit.XOffset,oy);
  Scrollbarseteventlessposition(Scroffsy,round(glblit.YOffset*1000.0));
end;

procedure TGLImageFrame.setoverlayfontsize(ind: integer; const Value: integer);
begin
 if (ind>=0) and (ind<=high(fontsizecache)) then
   begin
     fontsizecache[ind]:=value;
     if assigned(glblit) then
       glblit.fontsizecache[ind]:=value;
   end;
end;

procedure TGLImageFrame.setscale(aspect: boolean);
begin
 if not aspect then
   MnuTrueScaleClick(nil)
 else
   MnuZoomfitClick(nil);
end;

procedure TGLImageFrame.test(i: integer);
var nno,n,ox,oy : single;
begin
 // routine om (onder case i of) verschillende "standaard" knop dingen te testen.
 // met name varianten van offset/aspect/zoom x/y door te voeren

      n:=glblit.zoomfitaspect(i,ox,oy);
   //   glblit.redrawafterchange; // propagate aspect ratios
      nno:=glblit.zoomx;
      {$ifdef blitdebug}
      log.logline(srcdebug,'oldzoom'+FloatToStrf(nno,fffixed,2,5),catwarning);
      {$endif}
      newzoom(n,nno);
      {$ifdef blitdebug}
      log.logline(srcdebug,'after nz'+FloatToStrf(glblit.zoomx,fffixed,2,5),catwarning);\
      {$endif}
      glblit.redrawafterchange;
//    end;
end;

procedure TGLImageFrame.putvinkje(cls, item: integer);
var i,j : Integer;
    x : tmenuitem;
begin
  if not assigned(popupmenu) then exit;
  i:=0;
  while i< PopupMenu.Items.Count do
    begin
      x:=PopupMenu.Items[i];
      if x.tag = cls then
        begin
          j:=0;
          while j<x.count do
            begin
              if x.Items[j].tag= item then
                begin
                  x.Items[j].Checked := true;
                  break;
                end;
              inc(j);
            end;
        end;
      inc(i);
    end;
end;

procedure TGLImageFrame.putvinkjeSender(cls: integer; sender: tobject);
var i,j : Integer;
    x : tmenuitem;
begin
  i:=0;
  while i< PopupMenu.Items.Count do
    begin
      x:=PopupMenu.Items[i];
      if x.tag = cls then
        begin
          j:=0;
          while j<x.count do
            begin
              if x.Items[j].tag= TMenuItem(Sender).tag then
                begin
                  x.Items[j].Checked := true;
                  break;
                end;
              inc(j);
            end;
        end;
      inc(i);
    end;
end;

procedure TGLImageFrame.redrawupdate;
begin
 glblit.redrawafterchange;
end;

{$ifdef usexml}
procedure TBW8ImageFrame.savetoxml(xml: TXmlConfig; key: string);
begin
  xml.setextendedvalue(key+'zoomx',glblit.zoomx);
  xml.setextendedvalue(key+'zoomy',glblit.zoomy);
  xml.setextendedvalue(key+'offsetx',glblit.xoffset);
  xml.setextendedvalue(key+'offsety',glblit.yoffset);
  xml.SetValue(key+'aspect',glblit.AspectOverride);
  xml.SetValue(key+'defaultmode',defaultmode);
  xml.SetValue(key+'mirrorhud',fmirrorhud);
  xml.SetValue(key+'detaillevel',fdetaillevel);
end;
{$endif}
procedure TGLImageFrame.putvinkjeglobal(cls: integer; b: boolean);
var i,j : Integer;
    x : tmenuitem;
begin
  i:=0;
  while i< PopupMenu.Items.Count do
    begin
      x:=PopupMenu.Items[i];
      if x.tag = cls then
        begin
          x.checked:=b;
        end;
      inc(i);
    end;
end;

procedure TGLImageFrame.MnuZoomfitClick(Sender: TObject);
begin
  glblit.setoverrideaspect(true);
//  glblit.set2zoom(1,1);
  glblit.xOffset := 0;   glblit.yOffset := 0;
  newzoom(1,glblit.ZoomX);

  glblit.refresh;
  WisPopupMenuZoomVinkje;
  putvinkjeglobal(tagzoomfit,true);
end;

procedure TGLImageFrame.loadimage(name:string;context:TBasisPictureContextObject);
begin
  if bwbuffer.bpp=8 then
    loadnewstylebmp(name,tbw32image(bwbuffer),foverlaydata,context);
  glblit.setoverlays(foverlaydata);
  glblit.LoadPicture(bwbuffer.imageWidth,bwbuffer.imageheight,bwbuffer.rawuntyped,bwbuffer.bpp);
  glblit.flushoverlay;
  glblit.refresh;
end;

procedure TGLImageFrame.buzoomminusClick(Sender: TObject);
var  z,z2: single;
begin
  z2:=glblit.zoomx;
  z:=roundpower2(z2);
  if z>=1/8 then
    newzoom(z/2,glblit.zoomx);
end;

procedure TGLImageFrame.buzoomplusClick(Sender: TObject);
var  z,z2 : single;
begin
  z2:=glblit.zoomx;
  z:=roundpower2(z2);
  if z<=8 then
    newzoom(z*2,z2);
end;
function offset2int(s:single):integer;

begin
  result:=round(s*1000.0);
  if result>1000 then result:=1000;
  if result<0 then result:=0;
end;

procedure TGLImageFrame.newzoom(z, z2: single);
var ax,ay,nox,noy : single;

begin
  {$ifdef blitdebug}
  log.logline(srcdebug,'newzoom:'+floattostrf(z,fffixed,3,5)+' oldzoom:'+floattostrf(z2,fffixed,3,5),catwarning);
  {$endif}
  if glblit.AspectOverride then
    begin
      nox:=(glblit.XOffset+0.5/z2)-0.5/z;
      noy:=(glblit.yOffset+0.5/z2)-0.5/z;
    end
  else
    begin
      ax:=glblit.AspectX;   ay:=glblit.AspectY;
      nox:=(glblit.XOffset+0.5/(z2*ax))-0.5/(z*ax);
      noy:=(glblit.yOffset+0.5/(z2*ay))-0.5/(z*ay);
    end;
  {$ifndef nobounds}
  if nox<0 then nox:=0;
  if noy<0 then noy:=0;

  if nox>1 then nox:=1;
  if noy>1 then noy:=1;
  {$endif}

//  nox:=glblit.XOffset;   noy:=glblit.yOffset;

  setzoomoffs(z,z,nox,noy);
end;

procedure TGLImageFrame.scrzoomChange(Sender: TObject);
var z,z2 : single;
begin
 z2:=glblit.zoomx;
 z:=position2zoom(scrzoom.Position);
 newzoom(z,z2);
end;

procedure TGLImageFrame.dudetailplusClick(Sender: TObject);
begin
  if fdetaillevel<=nrOverlayLayers then  // allow level 6 -> invisble.
    begin
      inc(fdetaillevel);
      glblit.setdetail(fdetaillevel);
      lbdetail.Caption:=inttostr(fdetaillevel);
      glblit.refresh;
    end;
end;

procedure TGLImageFrame.focusblob(nr: integer);
var
   nz,nx,ny : single;
   r : trect;
begin
  r:=overlay.blob[nr];
  nz:=glblit.focuszoom(r,nx,ny);
  setzoomoffs(nz,nz,nx,ny);
end;

procedure TGLImageFrame.budetailminusClick(Sender: TObject);
begin
 if fdetaillevel>1 then
    begin
      dec(fdetaillevel);
      glblit.setdetail(fdetaillevel);
      lbdetail.Caption:=inttostr(fdetaillevel);
      glblit.refresh;
    end;
end;

procedure TGLImageFrame.buStandaardClick(Sender: TObject);
procedure zoommatch(i:integer);
var n , nno,ox,oy:single;
begin
       n:=glblit.zoomfitaspect(i,ox,oy);
   //   glblit.redrawafterchange; // propagate aspect ratios
      nno:=glblit.zoomx;
      {$ifdef blitdebug}
      log.logline(srcdebug,'oldzoom'+FloatToStrf(nno,fffixed,2,5),catwarning);
      {$endif}

      setzoomoffs(n,n,ox,oy);
      {
      glblit.xOffset := 0;   glblit.yOffset := 0;
      newzoom(n,nno);

      glblit.xOffset := ox;  glblit.yOffset := oy;
      }
      {$ifdef blitdebug}
      log.logline(srcdebug,'after nz'+FloatToStrf(glblit.zoomx,fffixed,2,5),catwarning);
      {$endif}
    //  glblit.redrawafterchange;
end;

begin
  case defaultmode of   // zoomfit
   0: begin
        glblit.setoverrideaspect(true);
        glblit.xOffset := 0;   glblit.yOffset := 0;
        newzoom(1,glblit.ZoomX);
        glblit.xOffset := 0;   glblit.yOffset := 0;
        glblit.refresh;
        WisPopupMenuZoomVinkje;
        putvinkjeglobal(tagzoomfit,true);
       end;
   1:  zoommatch(0);  // zoom 1:1 fit width
   2:  zoommatch(1);  // zoom 1:1 fit height
   end;
end;

procedure TGLImageFrame.mouseclickoncanvas(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var redx,redy:single;

begin
  if button=mbLeft then
    begin
      // faspectx
     if glblit.AspectOverride Then
       begin
        redx:=glblit.XOffset+(x/glblit.width - 0.5) /glblit.ZoomX ;
        redy:=glblit.YOffset+(y/glblit.height- 0.5) /glblit.Zoomy ;
       end
     else
       begin
        redx:=glblit.XOffset+(x/glblit.width - 0.5) /(glblit.ZoomX*glblit.aspectx) ;
        redy:=glblit.YOffset+(y/glblit.height- 0.5) /(glblit.ZoomY*glblit.aspectY);
       end;
     glblit.set2offs(redx,redy);
     Scrollbarseteventlessposition(Scroffsy,round(glblit.YOffset*1000.0));
     Scrollbarseteventlessposition(Scroffsx,round(glblit.XOffset*1000.0));

     glblit.redrawafterchange;
    end;
end;

procedure TGLImageFrame.clear;
begin
 if assigned(glblit) then
   glblit.clear;
end;

procedure TGLImageFrame.clearoverlay;
begin
  glblit.clear;
end;

function TGLImageFrame.getoverlay: TOverlaylayerdata;
begin
 result:=fhuddata;
end;

function TGLImageFrame.getoverlayfontsize(ind: integer): integer;
begin
 result:=fontsizecache[ind]
end;

function TGLImageFrame.getviewableheight: integer;
begin
  result:=picpanel.height;
end;

procedure TGLImageFrame.drawtimings(x, y, yincr: integer;lastoverall:integer);
begin
   hud.DrawText(x,y,'Overall: '+inttostr(lastoverall)+'us',clyellow);
   hud.DrawText(x,y+yincr,   'Refresh:'+inttostr(ftimings[timerefresh])+'us',clyellow);
   hud.DrawText(x,y+yincr*2, 'LoadImage:'+inttostr(ftimings[timebeeld])+'us',clyellow);
   hud.DrawText(x,y+yincr*3, 'flushoverlay:'+inttostr(ftimings[timeflushoverlay])+'us',clyellow);
   hud.DrawText(x,y+yincr*4,   'Refresh1:'+inttostr(glblit.ftimings[blitrefresh1])+'us',clyellow);
   hud.DrawText(x,y+yincr*5,   'Refresh2:'+inttostr(glblit.ftimings[blitrefresh2])+'us',clyellow);
   hud.DrawText(x,y+yincr*6,   'Refresh3:'+inttostr(glblit.ftimings[blitrefresh3])+'us',clyellow);
   hud.DrawText(x,y+yincr*7,   'Refresh4:'+inttostr(glblit.ftimings[blitrefresh4])+'us',clyellow);
//   hud.DrawText(x,y+yincr*8,   'Refresh5:'+doit,clyellow);
end;

procedure TGLImageFrame.hudprepare(img:tbaseimage);
begin
  hud.clear;
  hud.width:=img.ImageWidth;
  hud.height:=img.Imageheight;
end;

{$ifdef usexml}
procedure TBW8ImageFrame.Loadfromxml(xml: TXmlConfig; key: string);
var asp : boolean;
    ox,oy,zx,zy : Single;
begin
  asp:=xml.getValue(key+'aspect',faspectoverride);
  zx:=xml.getextendedvalue(key+'zoomx',glblit.zoomx);
  zy:=xml.getextendedvalue(key+'zoomy',glblit.zoomy);

  ox:=xml.getextendedvalue(key+'offsetx',glblit.xoffset);
  oy:=xml.getextendedvalue(key+'offsety',glblit.yoffset);
  glblit.setall(ox,oy,zx,zy,asp);
  Scrollbarseteventlessposition(Scroffsy,round(oy*1000.0));
  Scrollbarseteventlessposition(Scroffsx,round(ox*1000.0));
  Scrollbarseteventlessposition(Scrzoom,zoom2position(zx));
  defaultmode:=xml.getValue(key+'defaultmode',-1);
  mirrorhud:=xml.getValue(key+'mirrorhud',fmirrorhud);
  fdetaillevel:=xml.getValue(key+'detaillevel',fdetaillevel);
  if defaultmode=-1  then
    begin
      defaultmode:=0;
      faspectoverride:=true;
      glblit.zoomx:=1;   glblit.zoomy:=1;      
      glblit.xoffset:=0; glblit.yoffset:=0;
    end;
 staterefresh:=true;
end;
{$endif}

procedure TGLImageFrame.Setselectableregion(const Value: boolean);
begin
  Fselectableregion := Value;
end;


procedure TGLImageFrame.setzoomoffs(zx, zy, ox, oy: single);
begin
  glblit.set2zoom(zx,zy);
  glblit.set2offs(ox,oy);

  Scrollbarseteventlessposition(Scroffsy,round(glblit.YOffset*1000.0));
  Scrollbarseteventlessposition(Scroffsx,round(glblit.XOffset*1000.0));

  Scrollbarseteventlessposition(Scrzoom,zoom2position(zx));
  glblit.redrawafterchange;
end;

procedure TGLImageFrame.setzoomx(zx: single);
begin
  glblit.set2zoom(zx,glblit.zoomy);
  Scrollbarseteventlessposition(Scrzoom,zoom2position(zx));
end;

procedure TGLImageFrame.setzoomy(zy: single);
begin
   glblit.set2zoom(glblit.zoomx,zy);
   Scrollbarseteventlessposition(Scrzoom,zoom2position(glblit.zoomx));
end;

end.

