unit stackform;

interface
{$i vwrdefines.inc}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Spin, inifiles, Dialogs, ExtCtrls, StdCtrls,

  avicap32, glblitfrm,baseimage,baseoverlay,switchfrm;

Type
  PtrInt = longint;

type
  TStackfrm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    btnConnect: TButton;
    pnlWebcam: TPanel;
    Timer1: TTimer;
    chmaze: TCheckBox;
    chstart: TCheckBox;
    Panel5: TPanel;
    spvalue: TSpinEdit;
    buexecute: TButton;
    chr: TCheckBox;
    chG: TCheckBox;
    CHB: TCheckBox;
    chdavidfilter: TCheckBox;
    ScrollBar1: TScrollBar;
    lbdrempel: TLabel;
    ScrollBar2: TScrollBar;
    Label1: TLabel;
    chcollision: TCheckBox;
    lbpixel: TLabel;
    panalrm: TPanel;
    buconfig: TButton;
    ScrollBar3: TScrollBar;
    Label2: TLabel;
    Button1: TButton;
    bugrab: TButton;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure pnlWebcamResize(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure buexecuteClick(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure buconfigClick(Sender: TObject);
    procedure ScrollBar3Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bugrabClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    hnd : THandle;
    bw8image1,bw8image2 : TBW32Image;
    mainimagedisplay : TGLImageFrame;
    FCaptureBIHSize : Integer;            // Size of capture bmp format info
    FCaptureBIH     : PBitmapInfoHeader;  // capture bmp format info
    FStreamBIHSize  : Integer;            // Size of stream bmp format info
    FStreamBIH      : PBitmapInfoHeader;  // stream bmp format info
    canvasbu1       : TOverlaydata;
    pixels          : integer;
    mazanimator     : integer;
    shotcount       : integer;
    ini :TInifile;
    nextsnap:boolean;
    pb : tperbeeld;
  public
    procedure framecallback(lpVHDR: PVideoHdr);
    procedure TekenopCameraImage(sender:tobject);
    procedure tekenopmeta (canvasbuf:TOverlaydata;x,y:integer;s:string;color:Tcolor);
  end;

var
  Stackfrm: TStackfrm;

implementation

uses timertst;


      const
        WM_Connect     = WM_USER + 10;
        WM_Disconnect  = WM_USER + 11;
        WM_GrabFrame   = WM_USER + 60;
        WM_SaveDIB     = WM_USER + 25;
        WM_Preview     = WM_USER + 50;
        WM_PreviewRate = WM_USER + 52;
        WM_Configure   = WM_USER + 41;

var lastframe : int64;
    lastframeproc : integer;
{$R *.dfm}

Const capturewidth = 640;
      captureheight= 480;
  CaptureColorDepth = 24;

function xFrameCallback(hCapWnd: HWnd; lpVHDR: PVideoHdr): DWord; stdcall;

begin
 // OwnerForm := TMainForm(capGetUserData(hCapWnd));
  stackfrm.framecallback(lpvhdr);
  Result := 1;
end;


function WidthBytes(I: LongInt): LongInt;
begin
  Result := ((I + 31) div 32) * 4;
end;


procedure TStackfrm.tekenopmeta (canvasbuf:TOverlaydata;x,y:integer;s:string;color:Tcolor);
begin
    {loccanvas.Draw(0,0,canvasbuf);
    loccanvas.Font.Name := 'Arial';                  // Proportioneel font is belangrijk bij gebruik van MetaFileZoomFactor
    loccanvas.Font.size := round(MetafileZoomFactor * 12);
    loccanvas.Font.Color := color; //Geel
    SetBkMode(loccanvas.Handle, TRANSPARENT);        // Transparante achtergrond
     }
    canvasbuf.layers[1].DrawText(620,460,s,color);
    canvasbuf.layers[1].DrawText(620,480,inttostr(lastframeproc),color);
    if chstart.checked then
       canvasbuf.layers[1].DrawText(250,220,'STACK',cllime); // 34
end;
procedure TStackfrm.Timer1Timer(Sender: TObject);
begin
// chdavidfilter.Checked:=not chdavidfilter.Checked;
end;

procedure CreateBmpHeader(var bmih: TBitmapInfoHeader;
                          AWidth, AHeight, ABitsPerPixel: Integer);
begin
  bmih.biSize := SizeOf(TBitmapInfoHeader);
  bmih.biWidth := AWidth;
  bmih.biHeight := AHeight;
  bmih.biPlanes := 1;
  bmih.biBitCount := ABitsPerPixel;
  bmih.biCompression := BI_RGB;
  bmih.biSizeImage := WidthBytes(bmih.biWidth * bmih.biBitCount) * bmih.biHeight * bmih.biPlanes;
  bmih.biXPelsPerMeter := 0;
  bmih.biYPelsPerMeter := 0;
  bmih.biClrUsed := 0;
  bmih.biClrImportant := 0;
end;

procedure TStackfrm.btnConnectClick(Sender: TObject);
begin
  capDriverConnect(hnd, 0);

   // read the really capture format
  FCaptureBIHSize := capGetVideoFormatSize(hnd);
  GetMem(FCaptureBIH, FCaptureBIHSize);
  capGetVideoFormat(hnd, wparam(FCaptureBIH), FCaptureBIHSize);
    {GetDriverCaps;

      // create header for half size pal with true color
      }

  FStreamBIHSize := SizeOf(TBitmapInfoHeader);
  GetMem(FStreamBIH, FStreamBIHSize);

//  move  (FCaptureBIH^,fstreambih^,fcapturebihsize);
  CreateBmpHeader(FStreamBIH^, CaptureWidth, CaptureHeight, 24);

  capSetVideoFormat(hnd, wparam(FStreamBIH), FStreamBIHSize);

   capPreviewRate(hnd, 15);
   capPreview(hnd, 1);

end;

procedure TStackfrm.buconfigClick(Sender: TObject);
begin
  if hnd<> 0 then
    SendMessage(hnd, WM_Configure, 0, 0);
end;

procedure TStackfrm.buexecuteClick(Sender: TObject);
var mask : cardinal;
begin
 bw8image1.LoadFile('image\'+inttostr(spvalue.Value)+'.bmp');
{ Mask:=$FF000000;
 if chg.checked then
   mask:=mask or $FF00;
 if chb.checked then
   mask:=mask or $FF;
 if chr.checked then
   mask:=mask or $FF0000;
 maskbmp(bw8image1,mask);}

 if chdavidfilter.checked then
    maskbmp2(bw8image1,ScrollBar1.Position,ScrollBar2.Position);


 mainimagedisplay.refresh;
end;

procedure TStackfrm.bugrabClick(Sender: TObject);
begin
 nextsnap:=true;
end;

procedure TStackfrm.Button1Click(Sender: TObject);
begin
 mazanimator:=0;
end;

const sectionset = 'settings';

function getexedir:string;
begin
  result:=ExtractFilePath(Application.ExeName);
end;

procedure TStackfrm.FormCreate(Sender: TObject);

begin
  nextsnap:=false;
  pb:=tperbeeld.create;
  ini :=TIniFile.Create(getexedir+'stackcam.ini');
  ScrollBar1.Position:=ini.ReadInteger(sectionset,'drempel',0);
  ScrollBar2.Position:=ini.ReadInteger(sectionset,'drempel2',0);
  ScrollBar3.Position:=ini.ReadInteger(sectionset,'drempel3',0);
  shotcount:=ini.ReadInteger('state','shotcount',0);
  chmaze.Checked:=ini.ReadBool(sectionset,'maze',false);
  chstart.Checked:=ini.ReadBool(sectionset,'start',false);
  chdavidfilter.Checked:=ini.ReadBool(sectionset,'davidfilter',false);
  chcollision.Checked:=ini.ReadBool(sectionset,'collision',false);
  spvalue.Enabled:=ini.ReadBool('state','simuenabled',false);
  buexecute.Enabled:=spvalue.Enabled;
  chr.Enabled:=spvalue.Enabled;
  chg.Enabled:=spvalue.Enabled;
  chb.Enabled:=spvalue.Enabled;
  bw8image1:=TBW32Image.create(nil);
  mainimagedisplay:=TGLImageFrame.create(nil);
  mainimagedisplay.frameinit(pnlWebcam,nil,nil);
  mainimagedisplay.overlayfontsize[0]:=20;
  mainimagedisplay.attach([]);
  bw8image1.ImageHeight:=captureheight;bw8image1.ImageWidth:=capturewidth;
  hnd:= capCreateCaptureWindowA('Capture Window', WS_CHILD or WS_VISIBLE,
                                    0, 0, CaptureWidth, CaptureHeight,
                                    panel5.handle, 0);
 capSetUserData(hnd, ptrint (Self));
 capSetCallbackOnFrame(hnd, @xFrameCallback);
 canvasbu1   := TOverlaydata.Create;
 canvasbu1.setwidth(capturewidth);
 canvasbu1.setheight(captureheight);
// bw8image1.OnRefreshed:=tekenopcameraimage;
// bw8image1.enablescrollbars:=true;
 bw8image2:=tbw32image.Create(nil);
 if fileexists('maze24.bmp') then
    bw8image2.LoadFile('maze24.bmp')
 else
   showmessage('maze24.bmp not found');
 refresh;
end;

procedure TStackfrm.FormDestroy(Sender: TObject);
begin
  ini.writeInteger(sectionset,'drempel',ScrollBar1.Position);
  ini.writeInteger(sectionset,'drempel2',ScrollBar2.Position);
  ini.writeInteger(sectionset,'drempel3',ScrollBar3.Position);
  ini.writeInteger('state','shotcount',shotcount);
  ini.writeBool(sectionset,'maze',chmaze.Checked);
  ini.writeBool(sectionset,'start',chstart.Checked);
  ini.writeBool(sectionset,'davidfilter',chdavidfilter.Checked);
  ini.writeBool(sectionset,'collision',chcollision.Checked);

  ini.Free;
end;

procedure TStackfrm.FormResize(Sender: TObject);
begin
  panel2.width:=self.Width-panel1.Width-10;
  panel2.height:=self.height-10;

  panel1.Realign;
  Panel3.Realign;
  pnlWebcam.Realign;
end;

procedure TStackfrm.framecallback(lpVHDR: PVideoHdr);
var p  : pbyte;
    cur: int64;
    s:string;
    tmr : int64;
    domaze : boolean;
begin
  starttimer(tmr);
  canvasbu1.Clear;
//  canvasbu1.setsize(capturewidth*16,captureheight*16);
  s:=endtimerwithresult(lastframe,lastframe);
  tekenopmeta(canvasbu1,50,50,s,clred);
  p:=pbyte(bw8image1.GetImagePointer(0,bw8image1.imageheight-1));
  move(lpVHDR.lpData^,p^,lpvhdr.dwBytesUsed);
  if nextsnap then
    begin
      bw8image1.SaveFile('snap'+inttostr(shotcount)+'.bmp');
      inc(shotcount);
      nextsnap:=false;
    end;

  if chdavidfilter.checked then
    maskbmp2(bw8image1,scrollbar1.position,scrollbar2.position);
  pixels:=0;
  if chcollision.Checked then
    begin
     pixels:=andtest(bw8image1,bw8image2,ScrollBar2.Position);
     lbpixel.caption:='Pixels '+inttostr(pixels);
     if pixels>ScrollBar3.Position then
       begin
       panalrm.Color:=clred;
       if mazanimator=0 then
         mazanimator  :=1;
       end
     else
       panalrm.Color:=cllime;

    end;
  domaze:=chmaze.checked;

  if mazanimator>0 then
    begin
      inc(mazanimator);
      if mazanimator=100 then
        mazanimator:=2;
      domaze:=odd(mazanimator);
    end;
  if domaze then
     addbmp(bw8image1,bw8image2);

  pb.hetbeeld:=bw8image1;
  pb.canvasbuf:=canvasbu1;
  mainimagedisplay.hudprepare(bw8image1);
  mainimagedisplay.newframe(0,pb);
  mainimagedisplay.Refresh;
  lastframeproc:=endtimerms(tmr);
end;

procedure TStackfrm.pnlWebcamResize(Sender: TObject);
begin
 mainimagedisplay.Height:=pnlWebcam.Height;
 mainimagedisplay.width:=pnlWebcam.width;
 mainimagedisplay.Refresh;
end;

procedure TStackfrm.ScrollBar1Change(Sender: TObject);
begin
 lbdrempel.caption:='Drempelhigh '+inttostr(tscrollbar(sender).Position);
end;

procedure TStackfrm.ScrollBar2Change(Sender: TObject);
begin
 Label1.caption:='Drempellow '+inttostr(tscrollbar(sender).Position);
end;

procedure TStackfrm.ScrollBar3Change(Sender: TObject);
begin
 Label2.caption:='Limiet '+inttostr(tscrollbar(sender).Position);
end;

procedure TStackfrm.TekenopCameraImage(sender: tobject);
begin
{if assigned(bw8image1) and assigned(canvasbu1) then
   drawonbuf(bw8image1,canvasbu1);}
end;

end.
