unit switchfrm;

interface
{$i vwrdefines.inc}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,

  {$Ifdef usexml}laz_xmlcfg,{$endif} baseimage, baseoverlay, candelautils;

type
   tperbeeld = class
                  hetbeeld:tbaseimage;
                  canvasbuf : TBasicOverlay;
   end;
//   TBasisPictureContextObject = tobject;
   TMetingenHierarchie = tobject;
   TFrameTarget = (target_simulatie,target_camera,target_beheer,target_load,target_top10,target_uitval,target_bofi,target_operator,target_bheerload,target_basegui);
   TMessageType = (msgcamstart=$41,msgcamstop=$42,msgtimerhit=$43,msgmetingen=$E0,msgsendmetingen=$ee,msgstorecurrentbeeld=$EF,msgstorebeeld=$F0,msgload=$f1,msgsave=$f2,msgprodload=$f3,msgnextsimu=$F4);
   TGUIMessage  = Class
                        targetcamera: integer;
                        targetissimu: boolean;
                        targetframe : TFrameTarget;
                        sourcecamera: integer;
                        sourceissimu: boolean;
                        sourceframe : TFrameTarget;
                        msgtype     : TMessageType;
                        msg         : String;
                        Miscdata  : array[0..3] of integer;
                       end;
  TDispatchMethod = procedure (x:TGUIMessage) of object;
  TDispatchMethodArray = Array of TDispatchMethod; 
  TSwitchFrame = class(TFrame)
  protected
    zoomstate : array of TImageZoomData;
    internalcamnrs : array of integer;
    prnt : TWincontrol;
  public
    { Public declarations }
    attached : boolean;
    procedure attach(p:array of Tperbeeld); virtual; abstract;
    procedure detach(perbeeld:array of tperbeeld);  virtual; abstract;
    procedure newframe(cameranr:integer;perbeeld:tperbeeld); virtual; abstract;
    Procedure Frameinit(prn : Tobject;metingen:TMetingenHierarchie;context:TObject=nil); virtual;  abstract;                       // avoid circular ref;
    procedure FrameClose; virtual; abstract;
{$Ifdef usexml}
    procedure Loadfromxml(xml:TXmlConfig;key:string); virtual;
    procedure savetoxml(xml:TXmlConfig;key:string); virtual;
    procedure saveallzoomstate(xml:TXmlConfig;key:string);
    procedure saveazoomstate(xml:TXmlConfig;key:string;nr:integer);
    procedure loadallzoomstate(xml:TXmlConfig;key:string);
    procedure loadazoomstate(xml:TXmlConfig;key:string;nr:integer);
        procedure setcamnrs (p:array of Tperbeeld);

{$endif}
    procedure setparenthandle(h:TWincontrol);
    function getmessage(src,tg: TFrameTarget; camnr: integer;simu: boolean; msgnr: TMessageType ;msg:string=''): TGUIMessage; virtual;
  end;
 TSwitchFrameType = Class of TSwitchFrame;

implementation

//uses cammgr;
{$R *.dfm}

{$ifdef usexml}
{ TSwitchFrame }
procedure TSwitchFrame.Loadfromxml(xml: TXmlConfig; key: string);
begin
 // idem.
end;

procedure TSwitchFrame.savetoxml(xml: TXmlConfig; key: string);
begin
 // we have no state in this form, but we don't declare it abstract otherwise frames that don't implement this would crash on startup
 // with abstract exception.
end;

procedure TSwitchFrame.saveallzoomstate(xml: TXmlConfig; key: string);
var i : integer;
begin
  xml.SetValue(key+'aantal',length(zoomstate));
  if length(zoomstate)>0 then
    begin
      for i:=0 to length(zoomstate)-1 do
        saveazoomstate(xml,key+'zoomstate'+inttostr(i)+'/',i);
     end;
end;

procedure TSwitchFrame.saveazoomstate(xml: TXmlConfig; key: string;
  nr: integer);
begin
  with zoomstate[nr] do
    begin
      xml.SetExtendedValue(key+'oldpanx',oldpanx);
      xml.SetExtendedValue(key+'oldpany',oldpany);
      xml.SetExtendedValue(key+'zoomx',zoomx);
      xml.SetExtendedValue(key+'zoomy',zoomy);
      xml.SetValue(key+'scrollbars',scrollbars);
    end;
end;

procedure TSwitchFrame.loadallzoomstate(xml: TXmlConfig; key: string);
var i,j : integer;
begin
  j:=xml.getValue(key+'aantal',0);
  if j>length(zoomstate) then
    j:=length(zoomstate);
  if j<length(zoomstate) then
    for i:=j to length(zoomstate)-1 do
      zoomstate[i].oldpanx:=-1;
  if j>0 then
    begin
      for i:=0 to j-1 do
        loadazoomstate(xml,key+'zoomstate'+inttostr(i)+'/',i);
     end;
end;

procedure TSwitchFrame.loadazoomstate(xml: TXmlConfig; key: string;
  nr: integer);
begin
  with zoomstate[nr] do
    begin
      oldpanx:=xml.getExtendedValue(key+'oldpanx',-1);
      oldpany:=xml.getExtendedValue(key+'oldpany',0);
      zoomx:=xml.getExtendedValue(key+'zoomx',1);
      zoomy:=xml.getExtendedValue(key+'zoomy',1);
      scrollbars:=xml.getValue(key+'scrollbars',false);
    end;
end;

procedure TSwitchFrame.setcamnrs(p: array of Tperbeeld);
var I : integer;
begin
  setlength(internalcamnrs,length(p));
  for i:=0 to length(p)-1 do
    internalcamnrs[i]:=TBaseCamera(p[i].cam).Cameranr;
end;
{$endif}
procedure TSwitchFrame.setparenthandle(h: TWinControl);
begin
 prnt:=h;
end;

function TSwitchFrame.getmessage(src,tg: TFrameTarget; camnr: integer;
  simu: boolean; msgnr: TMessageType ;msg:string=''): TGUIMessage;
begin
  result:=TGUIMessage.create;
  result.targetcamera:=camnr;
  result.targetissimu:=simu;
  result.targetframe:=tg;
  result.msgtype:=msgnr;
  result.sourcecamera:=camnr;
  result.sourceissimu:=false;
  result.sourceframe:=src;
  result.msg:=msg;
end;

end.
