unit timertst;

interface

uses windows,sysutils,baseimage,graphics,dialogs;

procedure starttimer(var tmr:int64);
function  endtimer(tmr : int64):string;
function  endtimerms(tmr : int64):int64;
function  endtimerus(tmr : int64):int64;

function  endtimermssingle(tmr : int64):single;
function  endtimerwithresult(tmr : int64;var v:int64):string;
//function  endtimerwithresultms(tmr : int64;var v:int64):integer;
//function  endtimerwithresultmsSingle(tmr : int64;var v:int64):single;
function  getfreq:int64; {$ifndef ver150}inline;{$endif}


{$ifdef havedisplayimage}
procedure drawonbuf(CameraImage:TBW8ImageDisplay;CameraImageOverlay:TMetaFile);
{$endif}

function andtest(b1,b2:Tbw32image;mask:integer):integer;
procedure addbmp(b1,b2:tbw32image);
procedure maskbmp(b1:tbw32image;mask:cardinal);
procedure maskbmp2(b1:tbw32image;drempel,drempel2:integer);

implementation

var
freq        : int64;

procedure starttimer(var tmr:int64);
begin
 queryperformancecounter(tmr);
end;

function  endtimer(tmr : int64):string;
var millisec: Single;
    time2:int64;
begin
  QueryPerformanceCounter(time2);
  millisec := ((time2-tmr)*1000) / getfreq;
  Str(millisec:1:1,result);
end;

function  endtimerwithresult(tmr : int64;var v:int64):string;
var millisec: Single;
    time2:int64;
begin
  QueryPerformanceCounter(time2);
  queryperformancefrequency(freq);
  millisec := ((time2-tmr)*1000) / getfreq;
  Str(millisec:1:1,result);
  v:=time2;
end;

function  endtimerms(tmr : int64):int64;
var     time2:int64;
begin
  QueryPerformanceCounter(time2);
  result:= (((time2-tmr)*1000) div  getfreq) ;
end;

function  endtimerus(tmr : int64):int64;
var     time2:int64;
begin
  QueryPerformanceCounter(time2);
  result:= (((time2-tmr)*1000000) div  getfreq) ;
end;


function  endtimermssingle(tmr : int64):single;
var     time2:int64;
begin
  QueryPerformanceCounter(time2);
  result:= ((time2-tmr)*1000) / getfreq;
end;

function  getfreq:int64;

begin
  queryperformancefrequency(result);
end;



{$ifdef havedisplayimage}

procedure drawonbuf(CameraImage:TBW8ImageDisplay;CameraImageOverlay:TMetaFile);
var
  C: TCanvas;
  PanX, PanY, ZoomX, ZoomY : Single;
  Rect : TRect; //(Left, Top, Right, Bottom: Integer);

begin
    PanX := CameraImage.PanX;
    PanY := CameraImage.PanY;
    ZoomX := CameraImage.ZoomX;
    ZoomY := CameraImage.ZoomY;

  C := TCanvas.Create;
  try
    C.Handle := GetDC( CameraImage.Handle );

    Rect.Left := Round( ZoomX * PanX );
    Rect.Top := Round( ZoomY * PanY );
    Rect.Right := Round( ZoomX * (CameraImage.ImageWidth + PanX) );
    Rect.Bottom := Round( ZoomY * (CameraImage.ImageHeight + PanY) );

    C.StretchDraw(Rect, CameraImageOverlay);
  finally
    ReleaseDC( CameraImage.Handle, C.Handle );
    C.Free;
  end;
end;

{$endif}

{$O+}
procedure addbmp(b1,b2:tbw32image);

var p,p2:pbyte;
    rp1,rp2 : integer;
    pend,pend2 : pbyte;
    n : integer;
begin
 rp1:=b1.rowpitch;
 rp2:=b2.rowpitch;
 p:=b1.GetImagePointer(0,b1.ImageHeight-1);
 p2:=b2.GetImagePointer(0,b2.ImageHeight-1);
 n:=b1.imageheight;
 pend:=b1.GetImagePointer(b1.Imagewidth-1,0);
 pend2:=b2.GetImagePointer(b2.Imagewidth-1,0);
 n:=pend2-p2;
 while (p<pend) and (p2<pend2) do
   begin
     n:=p^+p2^;
     if n>255 then n:=255;
     p^:=n;
     inc(p); inc(p2);
   end;
end;
procedure maskbmp(b1:tbw32image;mask:cardinal);
var p,p2:pbyte;
    rp1,rp2 : integer;
    pend,pend2 : pbyte;
    n : integer;
begin
 rp1:=b1.rowpitch;
 p:=b1.GetImagePointer(0,b1.ImageHeight-1);
 n:=b1.imageheight;
 pend:=b1.GetImagePointer(b1.Imagewidth-1,0);
 while (p<pend) do
   begin
     pcardinal(p)^:=pcardinal(p)^ and mask;
     inc(p,3);
   end;
end;

{$pointermath on}

function andtest(b1,b2:Tbw32image;mask:integer):integer;

var p,p2:pcardinal;
    rp1,rp2 : integer;
    pend,pend2 : pcardinal;
    res,n : integer;
begin
 rp1:=b1.rowpitch;
 p:=pcardinal(b1.GetImagePointer(0,b1.ImageHeight-1));
 p2:=pcardinal(b2.GetImagePointer(0,b2.ImageHeight-1));
 pend:=pcardinal(b1.GetImagePointer(b1.Imagewidth-1,0));
 res:=0;
 while (p<pend) do
   begin
     n:=(p^ and P2^) and $FFFFFF;
     if word(n)=65535 then
       begin
         pword(p)^:=0;
         pchar(p)[2]:=#0;
         inc(res);
       end;

      inc(p,3); inc(p2,3);
   end;
 result:=res;
end;

procedure maskbmp2(b1:tbw32image;drempel,drempel2:integer);
var p,p2:pbyte;
    rp1,rp2 : integer;
    pend,pend2 : pbyte;
    n : integer;
begin
 rp1:=b1.rowpitch;
 p:=b1.GetImagePointer(0,b1.ImageHeight-1);
 n:=b1.imageheight;
 pend:=b1.GetImagePointer(b1.Imagewidth-1,0);
 while (p<pend) do
   begin
     n:=(3*p[2]+P[1]) div 4 -p[0]; //rgb
     if n<0 then
       n:=0;
     if n>255 then
       n:=255;
     //p[0]:=n; p[1]:=n; p[2]:=n;
     if (n>drempel2) and (n<drempel) then
       begin
         pword(p)^:=255; p[2]:=255;
       end
     else
       begin
//         n:=pcardinal(p)^ AND $FF000000;
//         pcardinal(p)^:=((pcardinal(p)^ and $00FEFEFE) shr 1) or n;
       end;
       ; // :=p[0]+n; p[1]:=p[1]+n; p[2]:=p[2]+n;

     inc(p,3);
   end;
end;
end.
